package com.arms.egovframework.javaservice.esframework.repository;

import com.arms.egovframework.javaservice.esframework.model.vo.v2.DocumentAggregations;
import com.arms.egovframework.javaservice.esframework.model.vo.메트릭_집계_결과_목록_합계;
import com.arms.egovframework.javaservice.esframework.model.vo.DocumentSearchResult;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과_목록_합계;
import org.springframework.data.elasticsearch.core.SearchHit;
import org.springframework.data.elasticsearch.core.mapping.IndexCoordinates;
import org.springframework.data.elasticsearch.core.query.Query;
import org.springframework.data.elasticsearch.repository.ElasticsearchRepository;
import org.springframework.data.repository.NoRepositoryBean;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

@NoRepositoryBean
public interface 공통저장소<T,ID extends Serializable> extends ElasticsearchRepository<T,ID> {


	메트릭_집계_결과_목록_합계 metricAggregateDocs(Query query);

	DocumentAggregations aggregateRecentDocs(Query query, V2 v2);

	DocumentAggregations aggregateDocs(Query query, V2 v2);

	//recentAll(true and false) 전부 조회
	List<T> findAllDocs();

	List<SearchHit<T>> findHitAllDocs();

	List<T> findRecentAllDocs();

	List<SearchHit<T>> findHitDocs(Query query);

	List<T> findDocs(Query query, String newIndex);

	DocumentSearchResult<T> findRecentHits(Query query);

	DocumentSearchResult<T> findHits(Query query);

	<S extends T> S save(S entity, String indexName) ;

	<S extends T> S  save(S entity);

	<S extends T> Iterable<S> saveAll(Iterable<S> entities);

	boolean 인덱스_존재_확인(String 인덱스명);

	boolean 인덱스삭제(String 삭제할_지라이슈인덱스);

	Set<String> findIndexNamesByAlias(IndexCoordinates indexCoordinates);

	boolean deleteIndex(IndexCoordinates indexCoordinates);

	String deleteDocById(String id, String indexName);


	String deleteDocByEntity(T t);

	List<T> findDocsByScrollApi(Query query);

	T findRecentDocById(ID id);

	 T findDocById(ID id);


}
